package SGP_Backend.SGP_Backend.model.entity;

import org.springframework.data.annotation.Id;
import jakarta.persistence.Entity;
import jakarta.persistence.EnumType;
import jakarta.persistence.Enumerated;
import jakarta.persistence.GeneratedValue;
import jakarta.persistence.GenerationType;
import jakarta.persistence.Table;
import lombok.Data;

@Data
@Entity
@Table(name = "usuarios")
public class UsuarioEntity {
    
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private Long id;

    private String nome;

    @Enumerated(EnumType.STRING)
    private TipoUsuario tipo;

    private String email;

    private String senha;
    
    public enum TipoUsuario {
        ADMIN, GERENTE, FUNCIONARIO, CLIENTE
    }

    public void validarUsuario() {
        if (this.nome == null || this.nome.isEmpty()) {
            throw new IllegalArgumentException("Nome do usuário não pode ser vazio");
        }
        if (this.tipo == null) {
            throw new IllegalArgumentException("Tipo de usuário não pode ser nulo");
        }
        if(this.email == null || this.email.isEmpty()) {
            throw new IllegalArgumentException("Email do usuário não pode ser vazio");
        }
    }
}
