package SGP_Backend.SGP_Backend.service;
import SGP_Backend.SGP_Backend.model.entity.UsuarioEntity;
import SGP_Backend.SGP_Backend.repository.UsuarioRepository;
import jakarta.transaction.Transactional;
import java.util.List;
import java.util.Optional;


public class UsuarioService {
    private final UsuarioRepository usuarioRepository;

    public UsuarioService(UsuarioRepository usuarioRepository) {
        this.usuarioRepository = usuarioRepository;
    }
    @Transactional
    public UsuarioEntity salvarUsuario(UsuarioEntity usuarioEntity) {
        usuarioEntity.validarUsuario();
        return usuarioRepository.save(usuarioEntity);
    }

    @Transactional
    public void deletarUsuario(UsuarioEntity usuarioEntity) {
        usuarioRepository.delete(usuarioEntity);
    }


    public UsuarioEntity buscarUsuarioPorNome(String nome) {
        return usuarioRepository.findByNome(nome);
    }

    @Transactional
    public Optional<UsuarioEntity> buscarPorId(Long id) {
    return usuarioRepository.findById(id);
    }

    
    public UsuarioEntity atualizarUsuario(UsuarioEntity usuarioEntity) {
        usuarioEntity.validarUsuario();
        return usuarioRepository.save(usuarioEntity);
    }

    public List<UsuarioEntity> buscarTodosUsuarios() {
        return usuarioRepository.findAll();
    }

}